<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-8">
                <div class="calculator">
                    <ihm-tools v-if="isTools" @first="onChange(0)" @back="onBack" @next="onNext" @last="onChange(dataObject.length - 1)"></ihm-tools>
                    <div class="modal__header">
                        <button
                            v-show="this.dataStep != 0"
                            ref="backElement"
                            @click="onBack"
                            type="button"
                            class="modal__header-btns modal__header-btns--back btn-back"
                            tabindex="0"
                        >
                            <i class="fas fa-arrow-left"></i>
                        </button>
                        <div class="modal__header-progress">
                            <div class="progress-bar__empty"></div>
                            <div
                                ref="progressElement"
                                class="progress-bar__fill"
                                :style="{ width: stepProgress + '%' }"
                            ></div>
                        </div>
                    </div>
                    <div
                        class="step"
                        v-show="dataStep == indexStep"
                        v-for="(step, indexStep) in dataObject"
                        :key="indexStep"
                    >
                        <div class="step__title">{{ step.title }}</div>
                        <div class="step__subtitle">{{ step.subtitle }}</div>
                        <div
                            v-for="(option, indexOption) in step.options"
                            :key="indexOption"
                            :class="[
                                'step__options',
                                step.type == 'icon'
                                    ? 'step__options--inline'
                                    : 'step__options--stacked'
                            ]"
                        >
                        </div>

                        <div
                            v-for="(input, indexInput) in step.inputs"
                            :key="indexInput"
                            class="col-md-12"
                        >
                            <ihm-input :value="input"></ihm-input>
                        </div>

                        <div v-show="step.inputs" class="col-md-12">
                            <button
                                @click="onNext"
                                class="btn btn-primary btn-block btn-next save"
                            >
                                Continue
                            </button>
                        </div>

                       

                        <div v-if="step.notes" class="step__footer">
                            <p class="step__footer-text">
                                {{ step.notes }}
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>

import IhmTools from './IhmToolsComponent'
import IhmInput from './IhmInputComponent'

export default {
    components: {
        IhmTools,
        IhmInput,
    },
    props: [],
    data() {
        return {
            dataStep: 0,
            dataObject: {},
            isTools: false
        };
    },
    created() {
        this.prepare();
    },
    methods: {
        prepare() {
            if (this.$route.query.tools) {
                this.isTools = true;
            }
            this.getObject(1);
        },
        getObject(id) {
            axios
                .get(`api/form/${id}`)
                .then(res => {
                    this.dataObject = res.data;
                    this.onChange(0);
                })
                .catch(err => {
                    console.warn(err.message);
                });
        },
        onNext() {
            this.onChange(this.dataStep + 1);
        },
        onBack() {
            this.onChange(this.dataStep - 1);
        },
        onChange(step) {
            if (step >= 0 && step < this.dataObject.length) {
                this.dataStep = step;

                return step;
            }

            return false;
        },
        onSubmit(value) {
            this.onNext();
        }
    },
    computed: {
        stepProgress() {
            return Math.round((this.dataStep / this.dataObject.length) * 100);
        }
    }
};
</script>

<style scoped></style>
